/* LoginController.m
 * A simple NiKit example
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or  implied, as to its
 * fitness for any particular use.
 * Written by Charles Lloyd.
 */

#import "LoginController.h"
#import <nikit/NILoginPanel.h>
#import <nikit/NIDomain.h>
#include <pwd.h>


@implementation LoginController

-init
{
	loginPanel = [NILoginPanel new];
	return self;
}

-displayResults
{
	[userNameField setStringValue:[loginPanel getUser:self]];	
	[passwordCorrectField setStringValue:([loginPanel isValidLogin:self] ? "YES":"NO")];
	return self;
}

-doLogin
{
	void *aDomainHandle;
	id aDomain = [[NIDomain alloc] init];
	[loginPanel setDelegate:self];
	[aDomain setConnection:"/"];
	aDomainHandle = [aDomain getDomainHandle];
	if (aDomainHandle != NULL) 
	[loginPanel runModalWithValidation:self inDomain:aDomainHandle 
		withUser:"root" withInstruction:"A Test App" allowChange:YES];
	else
	NXRunAlertPanel(NULL, "The NetInfo domain is invalid", 0, 0, 0);
	[aDomain free];
	return self;
}


-loginClicked:sender
{
	[self doLogin];
	[self displayResults];
	return self;
}
//////////////////////////////////////
// Delegate methods
//////////////////////////////////////
-(BOOL)panel:thePanel authenticateUser:(const char *)username 
	withPassword:(const char *)passwordString inDomain:(const void *)domain
{
	struct passwd *aPassword;
	aPassword = getpwnam(username);
	if (aPassword != NULL) {
		char *usersCryptPass = aPassword->pw_passwd;
		char *testCryptPass = crypt((char*)passwordString, usersCryptPass);
		if ( strcmp(usersCryptPass, testCryptPass) == 0 )
			return YES;
	}
	return NO;
}

@end
